## klibc 2.0.13

=== debian/changelog ===
klibc (2.0.13-4ubuntu0.1) noble-security; urgency=medium

  * SECURITY UPDATE: improper pointer arithmetic
    - debian/patches/CVE-2016-9840.patch: remove offset pointer optimization
      in usr/klibc/zlib/inftrees.c.
    - CVE-2016-9840
  * SECURITY UPDATE: improper pointer arithmetic
    - debian/patches/CVE-2016-9841.patch: remove offset pointer optimization
      in usr/klibc/zlib/inffast.c.
    - CVE-2016-9841
  * SECURITY UPDATE: memory corruption during compression
    - debian/patches/CVE-2018-25032.patch: addresses a bug that can crash
      deflate on rare inputs when using Z_FIXED.
    - CVE-2018-25032
  * SECURITY UPDATE: heap-based buffer over-read
    - debian/patches/CVE-2022-37434-1.patch: adds an extra condition to check
      if state->head->extra_max is greater than len before copying, and moves
      the len assignment to be placed before the check in
      usr/klibc/zlib/inflate.c.
    - debian/patches/CVE-2022-37434-2.patch: in the previous patch, the
      placement of the len assignment was causing issues so it was moved
      within the conditional check.
    - CVE-2022-37434

 -- Ian Constantin <ian.constantin@canonical.com>  Tue, 21 May 2024 11:39:42 +0300

klibc (2.0.13-4) unstable; urgency=medium

  [ Sven Joachim ]
  * debian/initramfs-tools/hooks/klibc-utils: Avoid the use of "cp -n"
    (Closes: #1055694).

  [ Salvatore Bonaccorso ]
  * debian/control: Add myself to Uploaders

 -- Salvatore Bonaccorso <carnil@debian.org>  Wed, 21 Feb 2024 13:08:58 +0100

klibc (2.0.13-3) experimental; urgency=medium

  * Install klibc shared library in /usr/lib

 -- Ben Hutchings <benh@debian.org>  Sat, 25 Nov 2023 00:49:35 +0000

klibc (2.0.13-2) unstable; urgency=medium

  * d/rules: Handle loong64 architecture (thanks to Peng Fan)
    (Closes: #1053742)

 -- Ben Hutchings <benh@debian.org>  Tue, 24 Oct 2023 18:11:43 +0200

klibc (2.0.13-1) unstable; urgency=medium

  * New upstream version:
    - time: Use clock_* system calls for time-of-day and sleep
      (Closes: #923098)
    - Install command links as appropriate (LP: #2028571)

 -- Ben Hutchings <benh@debian.org>  Mon, 31 Jul 2023 15:04:13 +0200

=== debian/watch ===
version=3
https://www.kernel.org/pub/linux/libs/klibc/2.0/klibc-([0-9.]+).tar.xz

## klibc 2.0.14

=== Makefile ===
SRCROOT = .

# *DOCUMENTATION*
# To see a list of typical targets execute "make help"

# kbuild compatibility
export srctree  := $(or $(KBUILD_SRC),$(shell pwd))
export objtree  := $(shell pwd)
export KLIBCSRC := usr/klibc
export VERSION := $(shell cat $(srctree)/$(KLIBCSRC)/version)
export KLIBCINC := usr/include
export KLIBCOBJ := usr/klibc
export KLIBCKERNELSRC ?= linux

export VPATH := $(srctree)

include $(srctree)/scripts/Kbuild.include

KLIBCROSS	?= $(CROSS_COMPILE)
export KLIBCROSS
export CC	:= $(KLIBCROSS)gcc
export LD	:= $(KLIBCROSS)ld
export AR	:= $(KLIBCROSS)ar
export RANLIB	:= $(KLIBCROSS)ranlib
export STRIP	:= $(KLIBCROSS)strip
export NM	:= $(KLIBCROSS)nm
export OBJCOPY  := $(KLIBCROSS)objcopy
export OBJDUMP  := $(KLIBCROSS)objdump

NOSTDINC_FLAGS := -nostdlib -nostdinc -isystem $(shell $(CC) -print-file-name=include)

ARCH	          := $(shell uname -m | sed -e s/i.86/i386/ \
			-e s/parisc64/parisc/ -e s/sun4u/sparc64/ \
			-e s/arm.*/arm/ -e s/sa110/arm/ \
			-e s/aarch64.*/arm64/ -e s/sh.*/sh/ \
			-e s/ppc64le/ppc64/)
export KLIBCARCH  ?= $(ARCH)
export KLIBCARCHDIR := $(shell echo $(KLIBCARCH) | sed -e s/s390x/s390/)

export HOSTCC     := gcc
export HOSTCFLAGS := -Wall -Wstrict-prototypes -O2 -fomit-frame-pointer
export PERL       := perl

# Location for installation
export prefix      = /usr
export bindir      = $(prefix)/bin
export libdir      = $(prefix)/lib
export mandir      = $(prefix)/man
export INSTALLDIR  = $(prefix)/lib/klibc
export INSTALLROOT =

# Create a fake .config as present in the kernel tree
# But if it exists leave it alone
$(if $(wildcard $(objtree)/.config),,\
  $(shell cp $(srctree)/defconfig $(objtree)/.config))

# Prefix Make commands with $(Q) to silence them
# Use quiet_cmd_xxx, cmd_xxx to create nice output
# use make V=1 to get verbose output

ifdef V
  ifeq ("$(origin V)", "command line")
    KBUILD_VERBOSE = $(V)
  endif
endif
ifndef KBUILD_VERBOSE
  KBUILD_VERBOSE = 0
endif

ifeq ($(KBUILD_VERBOSE),1)
  quiet =
  Q =
else
  quiet=quiet_
  Q = @
endif

# If the user is running make -s (silent mode), suppress echoing of
# commands

ifneq ($(findstring s,$(MAKEFLAGS)),)
  quiet=silent_
endif

export quiet Q KBUILD_VERBOSE

# Do not print "Entering directory ..."
MAKEFLAGS += --no-print-directory

# Shorthand to call Kbuild.klibc
klibc := -f $(srctree)/scripts/Kbuild.klibc obj

# Very first target
.PHONY: all klcc klibc
all: klcc klibc

$(objtree)/.config: $(srctree)/defconfig
	@echo "defconfig has changed, please remove or edit .config"
	@false

$(KLIBCKERNELSRC)/include:
	@echo 'Missing kernel UAPI headers in $(KLIBCKERNELSRC)/include.'
	@echo 'Install them by running:'
	@echo '    make headers_install INSTALL_HDR_PATH=$(abspath $(KLIBCKERNELSRC))'
	@echo 'in the kernel source directory.'
	@false

rpmbuild = $(shell which rpmbuild 2>/dev/null || which rpm)

klibc.spec: klibc.spec.in $(KLIBCSRC)/version
	sed -e 's/@@VERSION@@/$(VERSION)/g' < $< > $@

# Build klcc - it is the first target
klcc: $(objtree)/.config $(KLIBCKERNELSRC)/include
	$(Q)$(MAKE) $(klibc)=klcc

klibc: $(objtree)/.config $(KLIBCKERNELSRC)/include
	$(Q)$(MAKE) $(klibc)=.

test: klibc
	$(Q)$(MAKE) $(klibc)=usr/klibc/tests

help:
	@echo	'Cleaning targets:'
	@echo	'  clean	- Remove most generated files'
	@echo	'  mrproper	- Remove all generated files + config'
	@echo	'  distclean	- mprproper + editor backup + patch files'
	@echo	''
	@echo	'Build targets:'
	@echo	'all		- Build all targets'
	@echo	'install	- Install klibc'
	@echo	'klcc		- Wrapper around gcc to compile against klibc'
	@echo	'test		- Run klibc tests'
	@echo
	@echo	'Build options:'
	@echo	'KLIBCKERNELSRC - Path to usr directory containing UAPI headers'
	@echo	'make V=0|1 [targets] 0 => quiet build (default), 1 => verbose build'
	@echo	'make V=2   [targets] 2 => give reason for rebuild of target'
	@echo
	@echo	'Sample invocation:'
	@echo	'make  KLIBCKERNELSRC=`pwd`/../linux/usr/'

###
# allow one to say make dir/file.o
# Caveat: works only for .c files where we have a Kbuild file in same dir
%.o: %.c FORCE
	 $(Q)$(MAKE) $(klibc)=$(dir $<) $(dir $<)$(notdir $@)

%.s: %.c FORCE
	 $(Q)$(MAKE) $(klibc)=$(dir $<) $(dir $<)$(notdir $@)

%.i: %.c FORCE
	 $(Q)$(MAKE) $(klibc)=$(dir $<) $(dir $<)$(notdir $@)

FORCE: ;
###
# clean: remove generated files
# mrproper does a full cleaning including .config and linux symlink
FIND_IGNORE := \( -name .git -o -name .pc \) -prune -o
quiet_cmd_rmfiles = $(if $(wildcard $(rm-files)),RM     $(wildcard $(rm-files)))
      cmd_rmfiles = rm -f $(rm-files)
clean:
	$(Q)$(MAKE) -f $(srctree)/scripts/Makefile.clean obj=.
	$(Q)find . $(FIND_IGNORE) \
		\( -name *.o -o -name *.a -o -name '.*.cmd' -o \
		   -name '.*.d' -o -name '.*.tmp' \) \
		-type f -print | xargs rm -f

rm-files := $(objtree)/.config linux
distclean mrproper: clean
	 $(Q)find . $(FIND_IGNORE) \
		\( -name '*.orig' -o -name '*.rej' -o -name '*~' \
		-o -name '*.bak' -o -name '#*#' -o -name '.*.orig' \
		-o -name '.*.rej' -o -size 0 \
		-o -name '*%' -o -name '.*.cmd' -o -name 'core' \) \
		-type f -print | xargs rm -f
	$(call cmd,rmfiles)

install: all
	$(Q)$(MAKE) -f $(srctree)/scripts/Kbuild.install obj=.

# This does all the prep work needed to turn a freshly exported git repository
# into a release tarball tree
release: klibc.spec
	rm -f .config

=== debian/changelog ===
klibc (2.0.14-1ubuntu1) questing; urgency=medium

  * Merge with Debian unstable (LP: #2112018). Remaining changes:
    - SECURITY UPDATE: improper pointer arithmetic
      + debian/patches/CVE-2016-9840.patch: remove offset pointer optimization
        in usr/klibc/zlib/inftrees.c.
      + CVE-2016-9840
    - SECURITY UPDATE: improper pointer arithmetic
      + debian/patches/CVE-2016-9841.patch: remove offset pointer optimization
        in usr/klibc/zlib/inffast.c.
      + CVE-2016-9841
    - SECURITY UPDATE: memory corruption during compression
      + debian/patches/CVE-2018-25032.patch: addresses a bug that can crash
        deflate on rare inputs when using Z_FIXED.
      + CVE-2018-25032
    - SECURITY UPDATE: heap-based buffer over-read
      + debian/patches/CVE-2022-37434-1.patch: adds an extra condition to check
        if state->head->extra_max is greater than len before copying, and moves
        the len assignment to be placed before the check in
        usr/klibc/zlib/inflate.c.
      + debian/patches/CVE-2022-37434-2.patch: in the previous patch, the
        placement of the len assignment was causing issues so it was moved
        within the conditional check.
      + CVE-2022-37434

 -- Benjamin Drung <bdrung@ubuntu.com>  Wed, 11 Jun 2025 11:05:35 +0200

klibc (2.0.14-1) unstable; urgency=medium

  * New upstream version:
    - parisc: Fix build with Linux 6.10+ (Closes: #1075820)

 -- Ben Hutchings <benh@debian.org>  Tue, 04 Mar 2025 04:37:02 +0100

klibc (2.0.13-4ubuntu1) oracular; urgency=medium

  * SECURITY UPDATE: improper pointer arithmetic
    - debian/patches/CVE-2016-9840.patch: remove offset pointer optimization
      in usr/klibc/zlib/inftrees.c.
    - CVE-2016-9840
  * SECURITY UPDATE: improper pointer arithmetic
    - debian/patches/CVE-2016-9841.patch: remove offset pointer optimization
      in usr/klibc/zlib/inffast.c.
    - CVE-2016-9841
  * SECURITY UPDATE: memory corruption during compression
    - debian/patches/CVE-2018-25032.patch: addresses a bug that can crash
      deflate on rare inputs when using Z_FIXED.
    - CVE-2018-25032
  * SECURITY UPDATE: heap-based buffer over-read
    - debian/patches/CVE-2022-37434-1.patch: adds an extra condition to check
      if state->head->extra_max is greater than len before copying, and moves
      the len assignment to be placed before the check in
      usr/klibc/zlib/inflate.c.
    - debian/patches/CVE-2022-37434-2.patch: in the previous patch, the
      placement of the len assignment was causing issues so it was moved
      within the conditional check.
    - CVE-2022-37434

 -- Ian Constantin <ian.constantin@canonical.com>  Tue, 21 May 2024 11:39:40 +0300

=== debian/control ===
Source: klibc
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Kernel Team <debian-kernel@lists.debian.org>
Uploaders: Ben Hutchings <benh@debian.org>, maximilian attems <maks@debian.org>, Salvatore Bonaccorso <carnil@debian.org>
Build-Depends: debhelper-compat (= 12), linux-libc-dev, m4 [sparc]
Section: libs
Standards-Version: 4.1.2
Vcs-Browser: https://salsa.debian.org/kernel-team/klibc
Vcs-Git: https://salsa.debian.org/kernel-team/klibc.git
# maybe some day replace with a real one?
Homepage: https://git.kernel.org/cgit/libs/klibc/klibc.git

Package: libklibc-dev
Section: libdevel
Architecture: linux-any
Depends: libklibc (= ${binary:Version}), linux-libc-dev, ${misc:Depends},
 ${perl:Depends}
Description: kernel headers used during the build of klibc
 This package contains the set of kernel headers that were required to
 build klibc and the utilities that ship with it.  This may or may
 not be a complete enough set to build other programs that link against
 klibc.  If in doubt, use real kernel headers instead.

Package: libklibc
Architecture: linux-any
Multi-Arch: same
Depends: ${misc:Depends}
Description: minimal libc subset for use with initramfs
 klibc is intended to be a minimalistic libc subset for use with
 initramfs.  It is deliberately written for small size, minimal
 entanglement, and portability, not speed.  It is definitely a work in
 progress, and a lot of things are still missing.

Package: klibc-utils
Architecture: linux-any
Multi-Arch: foreign
Depends: libklibc (= ${binary:Version}), ${misc:Depends}
Description: small utilities built with klibc for early boot
 This package contains a collection of programs that are linked
 against klibc. These duplicate some of the functionality of a
 regular Linux toolset, but are typically much smaller than their
 full-function counterparts.  They are intended for inclusion in
 initramfs images and embedded systems.
